c============================================
c This takes a runnumber and a part name,
c runs over the appropriate runXXX.dat file
c and produces the histoscope_xxxx.hbook file
c=============================================
      program CreateHbFile
      implicit none
#include "svtcommon.inc"
      integer numarg,iargc,read_event
      character*80 dataFileBase, partName
      character*80 charRunNumber
      integer dfbLength, pnLength, rnLength
      integer i, j, istat, nn, dummy, icycle
      character*80 inpar(4)
      character*200 inFile
      character*200 hbkFile
      character*2   charChipNumber
      character*80  tit
      character*200 error_string
      integer nrunold,nevold,runpointer
      logical customize
      integer nreport

      data nreport /100/
      data customize /.false./

c================================================
c Get the environmental variable DATA_DIR
c================================================
      dataFileBase(1:1) = ' '                ! paranoia
      call getenv("DATA_DIR",dataFileBase)
      if (dataFileBase(1:1) .eq. ' ') then
         print *,' The environmental variable DATA_DIR is not defined'
         stop
      end if
c==================================
c Get the number of parameters
c==================================
      numarg = iargc()
      if (numarg .lt. 1 .or. numarg .gt. 4) then
	call outusage
        stop
      endif  
c==============================================
c Load the parameters into character variables
c==============================================
	do i=1,numarg
	   call getarg(i, inpar(i))
        end do 
c==============================================
c Get the options first 
c==============================================
	runpointer = 1
	do i=1,numarg
	   if (inpar(i)(1:1) .ne. "-") goto 60
	   runpointer = runpointer + 1
	   if (inpar(i)(2:2) .eq. 'c') then
	      customize = .true. 
           else if (inpar(i)(2:2) .eq. 'n') then
	      read(inpar(i)(3:80),'(i77)') nreport
           else
	      call outusage
	      stop
           end if
        end do
 60   continue
c==================================
c Get the runumber and part_name
c==================================
      if (runpointer .gt. numarg) then
	call outusage
	stop
      end if
      partName(1:1) = ' '                     ! paranoia
      charRunNumber = inpar(runpointer)
      if (runpointer .lt. numarg) partName = inpar(numarg)
c=================================================================
c build the input / output file names (code stolen from quickfit)
c=================================================================
      dfbLength = 0
      do i = 1, 80
         if (dataFileBase(i:i).eq.' ') goto 11
         dfbLength = dfbLength + 1
      enddo
11    continue

      pnLength = 0
      do i = 1, 80
         if (partName(i:i).eq.' ') goto 12
         pnLength = pnLength + 1
      enddo
12    continue

      rnLength = 0
      do i=1,10
         if (charRunNumber(i:i) .eq. ' ') goto 13
         rnLength = rnLength + 1
      end do
 13   continue

      inFile  = dataFileBase(1:dfbLength)//'/'//partName(1:pnLength)
     +          //'/run'//
     +          charRunNumber(1:rnLength)//'.dat'

      hbkFile = dataFileBase(1:dfbLength)//'/'//partName(1:pnLength)
     +          //'/histoscope_'//
     +          charRunNumber(1:rnLength)//'.hbook'

      print *,' Will process ',inFile,' and output',hbkFile
c=====================================
c Set the Hbook limit
c=====================================
      call hlimit(NPAWC)
C============================================================
C Open the hbook file
C============================================================
      call hropen(55,'outrz',hbkFile,'N',1024,istat)
      if (istat .ne. 0) then
           print *,' Error opening ',hbkFile
           stop
      endif
C============================================================
C Read the header of the data file
C============================================================
      i = 10
      if (customize) i = 1
      dummy = read_event(i, inFile, nchip, nhit)
      if (dummy .ne. 0) then
           call error_message(dummy, error_string)
           print *,'Error from read_event ... reading event record'
           print *,'Error code = ',dummy,'  ',error_string
           stop
      end if
C================================================================
C Book the histograms (need to know number of chips from header)
C=================================================================
      nn = nchip - 1
      do i=0,nn
           write(charChipNumber,'(i2)') i
           tit =  'Chip '//charChipNumber//' map'
           call hbook1(100+i,tit,128,0.,128.,0)
      end do
      call hbook1(100+nchip,'All Chips Map$',128*nchip,0.,128.*nchip,0)
      call hbook2(500, 'Threshold scan$', 64, -0.5, 63.5,
     +                 128*nchip, 0., 128.*nchip, 0)
      call hbook2(501, 'Threshold scan fired-channels$',
     +                 64, -0.5, 63.5,
     +                 128*nchip, 0., 128.*nchip, 0)
      call hbook2(502, 'Charge scan$',
     +                 64, -0.5, 63.5,
     +                 128*nchip, 0., 128.*nchip, 0)
      call hbook2(503, 'Charge scan-fired channels$',
     +                 64, -0.5, 63.5,
     +                 128*nchip, 0., 128.*nchip, 0)
C=======================================================
C Read events
C========================================================
      print *,' Reporting every ',nreport,' events' 
      nrunold = 0
      nevold  = 0
      i = 2
 100  dummy = read_event(2, inFile, nchip, nhit)
      if (dummy .eq. 0) then
           j = nev/nreport
           if (nreport*j+1.eq.nev) then
              print *,'processing run ',nrun,' event ',nev
           end if
           do i=1,nhit
              call hfill(100+ichipnum(i), float(ichan(i)), 0. , 1.)
              call hfill(100+nchip, 128.*ichipnum(i)+ichan(i), 0., 1.)
              call hfill(500, float(ithr_dac(i)), 
     +                        128.*ichipnum(i)+ichan(i), 1.)
              call hfill(502, float(ical_dac(i)), 
     +                        128.*ichipnum(i)+ichan(i), 1.)
              if (ical_msk(i) .eq. 1 .and. icha_msk(i) .eq. 1) then
                 call hfill(501, float(ithr_dac(i)), 
     +                           128.*ichipnum(i)+ichan(i), 1.)
                 call hfill(503, float(ical_dac(i)), 
     +                           128.*ichipnum(i)+ichan(i), 1.)
              endif
           end do
           goto 100
      else if (dummy .ne. -1) then
           call error_message(dummy, error_string)
           print *,'Error from read_event'
           print *,'Last event processed was run ',nrunold,' event ',nevold
           print *,'Error code = ',dummy,'  ',error_string
           stop
      end if
c=================================================
c Done
c=================================================
      print *,' Now outputting histograms....'
      do i=1,nchip
           call hrout(100+i-1, icycle, ' ')
      end do
      call hrout(100+nchip, icycle, ' ')
      call hrout(500,       icycle, ' ')
      call hrout(501,       icycle, ' ')
      call hrout(502,       icycle, ' ')
      call hrout(503,       icycle, ' ')
      call hrend('outrz')
      close(55)
      end


c=================================================
C Outpput the usage info to the user
c=================================================
	subroutine outusage
	print  *,' Usage: CreateHbFile [-c -nXXX] run [part]'
        print  *,
     *       ' Where: -c    : customize format checks [default all on]'
        print  *,
     *       '        -nXXX : report every XXX events [default = 100]'
        print  *,
     *       '        run   : run number [must be positive]'
        print  *,
     *       '        part  : part name [optional]'
	return
	end