#include "error.h"
#include "reglist.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "cal_svtdef.h"
#include "cal_global.h"
/*****************************************************************/
/*****************************************************************/
/*****************************************************************/
/*****************************************************************/
/*****************************************************************/
/* THIS IS AN EXACT COPY OF THE FUNCTION CONTAINED IN THE FILE   */
/*                oasis_new/src/cal/cal_utils.c                  */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*   takes "value", looks at the first "how_many"                */
/*   bits, ignores all higher order bits, and                    */
/*   returns a "value" with the bit order switched               */
/*****************************************************************/
int switch_bits(int value, int how_many)
{
    int mask;
    int i;
    int this_bit_number;
    int return_value;
    int temp;
    int reversed_bit_number;
    if (how_many < 0) {
      how_many = 0;
    }
    if (how_many > 32) {
      how_many = 32;
    }
    mask = 0;
    for (i=1; i<=how_many; i++) {
      this_bit_number=i-1;
      mask = mask | (1 << this_bit_number);
    }
    temp = value & mask;
    return_value = 0;
    for (i=1; i<=how_many; i++) {
         this_bit_number=i-1;
         reversed_bit_number = how_many - this_bit_number -1;
         mask = 1 << this_bit_number;
         if ( (temp & mask) != 0) {
            return_value = return_value | (1 << reversed_bit_number);
          }
    }
    return (return_value);
}


/*****************************************************************/
/*****************************************************************/
/*****************************************************************/
/*****************************************************************/
/*****************************************************************/
/* THIS IS AN EXACT COPY OF THE FUNCTION CONTAINED IN THE FILE   */
/*                oasis_new/src/cal/cal_utils.c                  */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/* dir = 0 takes num, extracts its four bytes, puts it in bytes  */
/* dir = 1 the other way around                                  */
/* returns zero on success                                       */
/*****************************************************************/
int cal_extract(int dir, int *num, char* bytes) {
  int shft[4] = {0, 8, 16, 24};
  int dummy;
  int i;
  if (dir !=0 && dir!=1) {
    return 1;
  }
  if (dir == 0) {
    *bytes     = (char) *num & 0xff;
    *(bytes+1) = (char) ((*num & 0xff00)     >> 8);
    *(bytes+2) = (char) ((*num & 0xff0000)   >> 16);
    *(bytes+3) = (char) ((*num & 0xff000000) >> 24);
  } else {
    *num = 0;
    for (i=0; i<4; i++) {
      dummy = (int) *(bytes+i);
      dummy = dummy & 0xff;
      if (shft[i] != 0) {
         dummy = dummy << shft[i];
       }
      *num = *num | dummy;
    }

  }
  return 0;
}


/*****************************************************************/
/*****************************************************************/
/*****************************************************************/
/*****************************************************************/
/*****************************************************************/
/* THIS IS AN EXACT COPY OF THE FUNCTION CONTAINED IN THE FILE   */
/*                oasis_new/src/cal/cal_utils.c                  */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*****************************************************************/
/* write to the output file                                      */
/*****************************************************************/
int cal_write_file(FILE **fp)
{
  int i, nwritten, nbytes, dummy;

  if (*fp == NULL) return 1;
  dummy    = cal_extract(1,&nbytes,cal_data_point);
  nwritten = fwrite(cal_data_point, 1, nbytes, *fp);
  if (nwritten != nbytes) return 1;


/***  for (i=0; i<nbytes; i++) {                         ***/
/***    dummy = fputc(*(cal_data_point+i), *fp);         ***/
/***    if (*(cal_data_point+i) != EOF) {                ***/
/***      if (dummy == EOF) return 1;                    ***/
/***    }                                                ***/
/***  }                                                  ***/

   return 0;
}



/*****************************************************************/
/*****************************************************************/
/*****************************************************************/
/*****************************************************************/
/*****************************************************************/
/* THIS IS AN EXACT COPY OF THE FUNCTION CONTAINED IN THE FILE   */
/*                oasis_new/src/cal/cal_utils.c                  */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/************************************************************************/
/* compress event record, return zero if OK                             */
/* take as input the uncompressed event record from "cal_data_point"    */
/************************************************************************/
int cal_compress_event_record() {
  int dummy, old_nbytes, i, new_nbytes, new_ishift, old_ishift;
  int ishift, dummy2;
  char buff[4];
  char* temp;
  int begin_data[MAX_NUM_CHIP];
  int end_data[MAX_NUM_CHIP];
/*----------------------------------------------------------------------*/
/* find the number of bytes in uncompressed record, save it into temp   */
/*----------------------------------------------------------------------*/
  dummy  = cal_extract(1, &old_nbytes, cal_data_point);
  temp   = (char *) malloc(old_nbytes);
  if (temp == NULL) return -1;
  for (i=0; i<old_nbytes; i++) {
    *(temp+i) = *(cal_data_point+i);
  }
  free(cal_data_point);
/*----------------------------------------------------------------------*/
/* find the number of bytes in the compressed record                    */
/* Remove run number (4 bytes), cont reg (4*nchips bytes),              */
/* masks (32*nchips bytes), chip pointers (8*nchips bytes),             */
/* xy_scan pointers (8 bytes).                                          */
/*----------------------------------------------------------------------*/
  new_nbytes = old_nbytes - 4 - 44*number_of_chips;
  if (xy_scan == 1) new_nbytes = new_nbytes - 8;
/*----------------------------------------------------------------------*/
/* get some space                                                       */
/*----------------------------------------------------------------------*/
  cal_data_point = (char *) malloc(new_nbytes);
  if (cal_data_point == NULL) {
    free(temp);
    return -1;
  }
/*----------------------------------------------------------------------*/
/* put in number of bytes                                               */
/*----------------------------------------------------------------------*/
 dummy = cal_extract(0, &new_nbytes, buff);
 for (i=0; i<4; i++) {
   *(cal_data_point + i) = buff[i];
 }
/*----------------------------------------------------------------------*/
/* put in record type flag                                              */
/*----------------------------------------------------------------------*/
  *(cal_data_point + 4) = 0x2;
/*----------------------------------------------------------------------*/
/* put in event number                                                  */
/*----------------------------------------------------------------------*/
  for (i=0; i<4; i++) {
    *(cal_data_point + 5 + i) = *(temp + 8 +i);
  }
/*----------------------------------------------------------------------*/
/* put in everything else                                               */
/* BUG IN FOLLOWING CODE WHEN TRYING TO READ FROM THE RIGHT 28-JAN-98   */
/*----------------------------------------------------------------------*/
/*  old_ishift = old_nbytes - 1;                                        */
/*  for (new_ishift = new_nbytes-1; new_ishift>8; new_ishift--) {       */
/*    *(cal_data_point + new_ishift) = *(temp + old_ishift);            */
/*    old_ishift--;                                                     */
/*  }                                                                   */
/*----------------------------------------------------------------------*/
/* FIX THE ABOVE, 28 JAN 1998                                           */
/*----------------------------------------------------------------------*/
/* - - - - - - - - - - - - - - - - -- - - - - - - - - - - */
/* put in the xy scan information                         */
/* - - - - - - - - - - - - - - - - -- - - - - - - - - - - */
  new_ishift = 9;
  if (xy_scan == 1) {
    old_ishift = 13 + 44*number_of_chips + 8;
    for (i=0; i<8; i++) {
      *(cal_data_point + new_ishift) = *(temp + old_ishift);
      new_ishift++;
      old_ishift++;
    }
  }
/* - - - - - - - - - - - - - - - - -- - - - - - - - - - - */
/* Find the old chip data pointers                        */
/* - - - - - - - - - - - - - - - - -- - - - - - - - - - - */
  ishift = 13 + 36 * number_of_chips;
  for (i=0; i<number_of_chips; i++) {
    dummy2 = cal_extract(1,&dummy,(temp+ishift));
    begin_data[i] = dummy;
    ishift = ishift + 4;
  }
  for (i=0; i<number_of_chips; i++) {
    dummy2 = cal_extract(1,&dummy,(temp+ishift));
    end_data[i] = dummy;
    ishift = ishift + 4;
  }
/* - - - - - - - - - - - - - - - - -- - - - - - - - - - - */
/* put the chip data in using the chip data pointers      */
/* - - - - - - - - - - - - - - - - -- - - - - - - - - - - */
  for (i=0; i<number_of_chips; i++) {
    for (ishift=begin_data[i]; ishift<=end_data[i]; ishift++) {
      *(cal_data_point + new_ishift) = *(temp + ishift);
      new_ishift++;
    }
  }
/*----------------------------------------------------------------------*/
/* Done                                                                 */
/*----------------------------------------------------------------------*/
  free(temp);
  return 0;
}
