/*-------------------------------------------------------*/
/* Change the format of a data file                      */
/*-------------------------------------------------------*/
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

int cal_extract(int, int*, char*);
int read_record(FILE*, char**);

int main(int argc, char* argv[]) {

FILE* infile;
FILE* outfile;
char* temp;
char* temp2;
char* msk_data;
int nread, num, i, nchips, itemp, nwritten, first, itemp2, j;
char buff[4];
/*-------------------------------------------------------*/
/* Make sure that both input files have been specified   */
/*-------------------------------------------------------*/
  if (argc != 3) {
    printf("usage: change_format input output\n");
    return(0);
  }
/*-------------------------------------------------------*/
/* Open input file for read, output file for write       */
/*-------------------------------------------------------*/
  infile = fopen(argv[1],"r");
  if (infile == NULL) {
    printf("cannot open file %s \n",argv[1]);
    return(0);
  }
  outfile = fopen(argv[2],"w");
  if (outfile == NULL) {
    printf("cannot open file %s \n",argv[2]);
    return(0);
  }
/*-------------------------------------------------------*/
/* start out by reading the begin run record             */
/* stick it into temp2                                   */
/*-------------------------------------------------------*/
  num = read_record(infile, &temp2);
  if (num < 0) {
    printf("cannot read begin run record \n");
    return(0);
  }
/*-------------------------------------------------------*/
/* Number of chips                                       */
/*-------------------------------------------------------*/
  nchips = *(temp2+8);
/*-------------------------------------------------------*/
/* New number of bytes in the record                     */
/* break it up into bytes, stick it into buff            */
/*-------------------------------------------------------*/
  num = num + 128 - 32*nchips;
  itemp = num;
  i = cal_extract(0, &itemp, buff);
/*-------------------------------------------------------*/
/* allocate a new chunk of memory, put the data in       */
/*-------------------------------------------------------*/
  temp = (char *) malloc(num);
  if (temp == NULL) {
    printf("error allocating memory \n");
    return(0);
  }
  for (i=0; i<4; i++) {
    *(temp+i) = buff[i];
  }
  for (i=4; i<9; i++) {
    *(temp+i) = *(temp2+i);
  }
  for (i=9; i<num; i++) {
    *(temp+i) = 0;
  }
/*-------------------------------------------------------*/
/* save the masks for later usage                        */
/*-------------------------------------------------------*/
  msk_data = (char *) malloc(32*nchips);
  if (msk_data == NULL) {
    printf("error allocating memory \n");
    return(0);
  }
  for (i=0; i<32*nchips; i++) {
    *(msk_data+i) = *(temp2+9+i);
  }
/*-------------------------------------------------------*/
/* write the begin-run record in                         */
/*-------------------------------------------------------*/
  nwritten = fwrite(temp, 1, num, outfile);
  if (nwritten != num) {
    printf("error writing begin run record \n");
    return(0);
  }
  free(temp2);
  free(temp);

/*=======================================================*/
/* okay, now we are ready to look at the events          */
/*=======================================================*/
  for (;;) {
    num = read_record(infile, &temp2);
    if (num == -1) return(0);   /* end of file reached  */
    if (num < 0) {
      printf("error reading file %s \n",argv[1]);
      return(0);
    }

/*- new number of bytes in the event record       -*/
    num = num + 32*nchips;
/*- reserve some memory                           -*/
    temp = (char *) malloc(num);
    if (temp == NULL) {
      printf("error allocating memory \n");
      return(0);
    }
/*- stick in the number of bytes                  -*/
    itemp = num;
    i = cal_extract(0, &itemp, buff);
    for (i=0; i<4; i++) {
      *(temp+i) = buff[i];
    }
/*- stick in run number, event number, number of chips control registers -*/
    itemp = 4 + 4 + 4 + 1 + 4*nchips;
    for (i=4; i<itemp; i++) {
      *(temp+i) = *(temp2+i);
    }
/*- stick in the masks                             -*/
    for (i=0; i<32*nchips; i++) {
      *(temp+itemp+i) = *(msk_data+i);
    }
/*- stick in the event data                        -*/
    first = 4 + 4 + 4 + 1 + 4*nchips + 32*nchips + 4*nchips + 4*nchips;
    for (i=first; i<num; i++) {
      *(temp+i) = *(temp2+i-32*nchips);
    }
/*- finally, the data pointers...itemp & itemp2                     -*/
    first = 4 + 4 + 4 + 1 + 4*nchips + 32*nchips;
    for (i=0; i<nchips; i++) {
      j = cal_extract(1, &itemp, (temp2+first-32*nchips+4*i)); 
      j = cal_extract(1, &itemp2,(temp2+first-32*nchips+4*nchips+4*i));
      itemp  = itemp  + 32*nchips;
      itemp2 = itemp2 + 32*nchips;
      j = cal_extract(0, &itemp,  (temp+first+4*i));
      j = cal_extract(0, &itemp2, (temp+first+4*nchips+4*i));
    }
/*- now we write it out                                    -*/
    nwritten = fwrite(temp, 1, num, outfile);
    if (nwritten != num) {
      printf("error writing output file \n");
      return(0);
    }
    free(temp2);
    free(temp);
  }
}

