#include <string.h>
#include <stdio.h>
#include <stdlib.h>

char* cal_data_point;

int cal_dump(int, FILE*);
int read_record(FILE*, char**);
void display_help();
int decode_input(char*, int*);
char* cal_fluff_record(char**, char**, char**);

int main(int argc, char* argv[]) {

FILE* infile;
int num, dummy, i, n, status, nev;
int j, compressed, record_type;
char* begin_record;
int flag = 0;
char* parameter_record = NULL;
FILE* dump_file;
char* command_result;
char input[200];
char output_file[200];
/*-----------------------------------------------------------*/
/* make sure that file has been specified                    */
/*-----------------------------------------------------------*/
  if (argc != 2) {
    printf("usage: dumpev file \n");
    status = fflush(stdout);
    return(0);
  }
/*-----------------------------------------------------------*/
/* open file to be read                                      */
/*-----------------------------------------------------------*/
  infile = fopen(argv[1],"r");
  if (infile == NULL) {
    printf("cannot open file %s \n",argv[1]);
    status = fflush(stdout);
    return(0);
  }
/*-----------------------------------------------------------*/
/* default: dump to the screen                               */
/*-----------------------------------------------------------*/
  dump_file = stdout;
/*-----------------------------------------------------------*/
/* display help                                              */
/*-----------------------------------------------------------*/
  display_help();
/*-----------------------------------------------------------*/
/* accept input                                              */
/*-----------------------------------------------------------*/
  strcpy(input," ");
  for (;;) {
    printf("\n \nYes ? \n");
    status = fflush(stdout);
/*    fgets(input,sizeof(input),stdin);  */
        scanf("%s",input);             
        status = fflush(stdin);
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - -*/
/* quit command                                               */
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - -*/
    if (strcmp(input,"q") == 0) return 0;
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - -*/
/* output toggle command                                      */ 
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - -*/
    if (strcmp(input,"o") == 0) {
      if (dump_file == stdout) {
	printf("enter filename for dump information \n");
        status = fflush(stdout);
	scanf("%s",output_file);
	dump_file = fopen(output_file,"w");
	if (dump_file == NULL) {
	  printf("error opening file %s \n",output_file);
          status = fflush(stdout);
	  return 0;
	}
      } else {
	fclose(dump_file);
	printf("will now dump event to console \n");
        status = fflush(stdout);
	dump_file = stdout;
      }
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - -*/
/* Okay, must be next, skip, or go to event                   */
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - -*/
    } else {
      status = decode_input(input, &n);
      if (status == 0) {
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - -*/
/* for loop over records                                      */
/* the loop index is bumped up at the end (since we do not    */
/* want to bump up the loop index for a parameter record      */
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - -*/
	for (i=0; (i<n || input[0]=='g'); ) {
	  num = read_record(infile, &cal_data_point);
	  if (num == -1) {
	    printf("reached end of file \n");
            status = fflush(stdout);
	    return 0;
	  }
	  if (num < -1) {
	    printf("error reading record \n");
            status = fflush(stdout);
	    return 0;
	  }
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - -*/
/* if it is a begin run record, save it.  Also, see if it     */
/* a compressed data file                                     */
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - -*/
	  if (flag == 0) {               
	    compressed = (int) *(cal_data_point+9);
	    compressed = compressed & 0x2;
	    if (compressed != 0) {       /* save begin run record  */
	      begin_record = (char *) malloc(num);
	      if (begin_record == NULL) {
		printf("error allocating memory \n");
		status = fflush(stdout);
		return 0;
	      }
	      for (j=0; j<num; j++) {
		*(begin_record+j) = *(cal_data_point+j);
	      }
	    }
	  }
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - -*/
/* get the record type.  1=begin run                          */
/*                       2=normal event                       */
/*                       3=compressed event                   */
/*                       4=parameter record                   */
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - -*/
	  if (flag == 0) {
	    record_type = 1;
	  } else if (compressed==0) {
	    record_type=2;
	  } else {
	    j = (int) * (cal_data_point+4);
	    j = j & 0xff;
	    if (j == 0x1) {
	      record_type = 4;
	    } else if (j == 0x2) {
	      record_type = 3;
	    } else {
	      printf("unknown record type \n");
	      status = fflush(stdout);
	      return 0;
	    }
	  }
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - -*/
/* if it is a parameter record, store it                      */
/* (and get rid of the previous one as well)                  */
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - -*/
	  if (record_type == 4) {
	      if (parameter_record != NULL) free(parameter_record);
	      parameter_record = (char *) malloc(num);
	      if (parameter_record == NULL) {
		printf("error allocating memory \n");
		status = fflush(stdout);
		return 0;
	      }
	      for (j=0; j<num; j++) {
		*(parameter_record+j) = *(cal_data_point+j);
	      }
	   }
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - - - -*/
/* if this is an event record in a compressed file, fluff it up   */
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - - - -*/
	  if (record_type == 3) {
	    command_result = 
	          cal_fluff_record(&begin_record, 
				   &parameter_record, 
				   &cal_data_point);
	    if (strcmp("OK",command_result) != 0) {
		printf("%s \n",command_result);
		status = fflush(stdout);
		return 0;
	    }
	  }
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - - - -*/
/* if we were asked to dump the next record, do it                */
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - - - -*/
	  if (input[0] == 'n' && record_type !=4) {
	    cal_dump(flag,dump_file);
            status = fflush(dump_file);
	  }
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - - - -*/
/* if we were asked to go to a given event, check it out          */
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - - - -*/
	  if (input[0] == 'g' && record_type != 4 && record_type != 1) {
             dummy = cal_extract(1,&nev,(cal_data_point+8));
             if (nev == n) {
		 cal_dump(1,dump_file);
		 status = fflush(dump_file);
	         i = n;
                 input[0] = 'k';     /* so as to get out of for loop */
	     }
	   }
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - - - -*/
/* close the for loop, bump the index if it is not a parameter    */
/* record, set flag to 1, release memory                          */
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - - - -*/
	  if (record_type != 4) i++;
	  flag = 1;
	  free(cal_data_point);
	}                            /* close the for loop */
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - - - -*/
/* unrecognized command, display help                             */
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - - - -*/
      } else {
	printf("unrecognized input \n");
        status = fflush(stdout);
	display_help();
      }
    }
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - - - -*/
/* close the for (;;) loop                                        */
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - - - -*/
  }
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - - - -*/
/* end-of-everything                                              */
/*- - - - - - - - - - - - - - - - - - -- - - - - - - - - - - - - -*/
}
     

/*----------------------------------------------------------*/
/* decode the input string                                  */
/*----------------------------------------------------------*/
int decode_input(char* input, int* n) {
 int status;

 if (input[0] != 's' && input[0] != 'n' && input[0] != 'g') return 1;

 if (strcmp(input,"n")==0) {
   *n=1;
   return 0;
 }
 if (strcmp(input,"s")==0) {
   *n=1;
   return 0;
 }
 if (strcmp(input,"g")==0) return 1;

 if (input[0] == 'n') {
   sscanf(input,"n%d",n);
   printf("dumping next %d records \n",*n);
   status = fflush(stdout);
 }
 if (input[0] == 's') {
   sscanf(input,"s%d",n);
   printf("skipping next %d records \n",*n);
   status = fflush(stdout);
 }
 if (input[0] == 'g') {
   sscanf(input,"g%d",n);
   printf("going to event %d \n",*n);
   status = fflush(stdout);
 }
 return 0;
}



void display_help() {
  int status;
  printf("h   : displays this help. \n");
  status = fflush(stdout);
  printf("nXX : dump next XX records.  Missing XX, dump next record. \n");
  status = fflush(stdout);
  printf("sXX : skip next XX records.  Missing XX, skip next record. \n");
  status = fflush(stdout);
  printf("o   : toggle output, screen vs file. \n");
  status = fflush(stdout);
  printf("gXX : dump record for event number XX. \n");
  status = fflush(stdout);
  printf("q   : quit. \n");
  status = fflush(stdout);
}
