/*-------------------------------------------------------*/
/* fixup files corrupted with bad trailer                */
/*-------------------------------------------------------*/
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

int cal_extract(int, int*, char*);
int read_record(FILE*, char**);

int main(int argc, char* argv[]) {

FILE* infile;
FILE* outfile;
char* temp2;
char* msk_data;
int nread, num, i, nchips, itemp, nwritten, first, itemp2, j, ishift;
char buff[4];
int begin_chip[6], end_chip[6];
int b1, b2, ishift_store, dummy, nev;
/*-------------------------------------------------------*/
/* Make sure that both input files have been specified   */
/*-------------------------------------------------------*/
  if (argc != 3) {
    printf("usage: fixup_trailer input output\n");
    return(0);
  }
/*-------------------------------------------------------*/
/* Open input file for read, output file for write       */
/*-------------------------------------------------------*/
  infile = fopen(argv[1],"r");
  if (infile == NULL) {
    printf("cannot open file %s \n",argv[1]);
    return(0);
  }
  outfile = fopen(argv[2],"w");
  if (outfile == NULL) {
    printf("cannot open file %s \n",argv[2]);
    return(0);
  }
/*-------------------------------------------------------*/
/* start out by reading the begin run record             */
/* stick it into temp2                                   */
/*-------------------------------------------------------*/
  num = read_record(infile, &temp2);
  if (num < 0) {
    printf("cannot read begin run record \n");
    return(0);
  }
/*-------------------------------------------------------*/
/* Number of chips                                       */
/*-------------------------------------------------------*/
  nchips = *(temp2+8);
/*-------------------------------------------------------*/
/* write the begin-run record in                         */
/*-------------------------------------------------------*/
  nwritten = fwrite(temp2, 1, num, outfile);
  if (nwritten != num) {
    printf("error writing begin run record \n");
    return(0);
  }
  free(temp2);
/*=======================================================*/
/* okay, now we are ready to look at the events          */
/*=======================================================*/
  for (;;) {
    num = read_record(infile, &temp2);
    if (num == -1) return(0);   /* end of file reached  */
    if (num < 0) {
      printf("error reading file %s \n",argv[1]);
      return(0);
    }
    dummy = cal_extract(1, &nev, (temp2+8));
/*- pointer to begin data chip 0  -*/
    ishift_store = 4 + 4 + 4 + 1 + 4*nchips + 32*nchips;
    ishift       = ishift_store;
/* extract this begin and end data          */
    for (i=0; i<nchips; i++) {
      dummy = cal_extract(1, &j, (temp2+ishift));
      begin_chip[i] =  j;
      ishift = ishift + 4;
    }
    for (i=0; i<nchips; i++) {
      dummy = cal_extract(1, &j, (temp2+ishift));
      end_chip[i] =  j;
      ishift = ishift + 4;
    }

/*- is this event okay ??????   */
    if ( ((end_chip[0]+1)==begin_chip[1]) &&
         ((end_chip[1]+1)==begin_chip[2]) &&
         ((end_chip[1]-begin_chip[1]) > 2)) {
            nwritten = fwrite(temp2, 1, num, outfile);
            if (nwritten != num) {
              printf("error writing output file \n");
              return(0);
	    }
	    free(temp2);
    } else {
      for (i=begin_chip[0]+2; i<end_chip[0]; i=i+2) {
          b1 = (int) *(temp2+i);
	  b2 = (int) *(temp2+i+1);
	  b1 = b1 & 0xff;
	  b2 = b2 & 0xff;
	  if (b1 == 0x80 && b2 == 0x0) {
	     end_chip[1]   = end_chip[0];
	     end_chip[0]   = i+1;
	     begin_chip[1] = i+2;
             goto write_it_out;
	     }
       }
	  
/* if we get here, TROUBLE    */
      printf("events are more screwed up than you think event %d\n",nev);
      return 0;

write_it_out:
      ishift = ishift_store + 4;
      j = begin_chip[1];
      dummy = cal_extract(0, &j, (temp2+ishift));
      ishift = ishift_store + 4*nchips;
      j = end_chip[0];
      dummy = cal_extract(0, &j, (temp2+ishift));
      ishift = ishift + 4;
      j = end_chip[1];
      dummy = cal_extract(0, &j, (temp2+ishift));
      nwritten = fwrite(temp2, 1, num, outfile);
      if (nwritten != num) {
              printf("error writing output file \n");
              return(0);
      }
      free(temp2);
    }
  }
}
