      subroutine bruteMin( chip, chan, a, b, step, nIter, stat )
      implicit none
      integer chip, chan, stat, nIter
      real    a, b, step

      include 'quickfit.inc'

      integer sa, sb, iter
      real    newA, newB, bestA, bestB, bestChisq, chisq,
     .        tmpA, tmpB

      real    chisquare

c+++++++++++++++++++++++++

      stat = -1

      bestA = a
      bestB = b

      bestChisq = chisquare(chip, chan, bestA, bestB)

      do iter = 1, nIter
         tmpA = bestA
         tmpB = bestB
         do sa = -1, 1
            newA = tmpA + step*sa
            do sb = -1, 1
               newB = tmpB + step*sb
               chisq = chisquare(chip, chan, newA, newB)
               if (chisq.lt.bestChisq) then
                  bestA = newA
                  bestB = newB
                  bestChisq = chisq
               endif
            enddo ! b
         enddo ! a
         step = step * 0.5
      enddo



      if (bestA.eq.a.and.bestB.eq.b) then
c Failed to find better point.
         stat = -1
      else
         a = bestA
         b = bestB
         stat = 0
      endif


      return
      end

