
c=== Constants.

      integer maxChips
      parameter( maxChips=14 )

      integer maxIter
      parameter( maxIter=10 )

      real    tolA, tolB
      parameter( tolA = 0.01, tolB = 0.01 )

      real    minCut, maxCut, widthFactor
      parameter( minCut=0.2, maxCut=0.8, widthFactor=2.383 )

      real    minArea
      parameter( minArea = 0.10 )

      real    maxArea
      parameter( maxArea = 0.95 )

      real    chisqCut 
      parameter( chisqCut = 100. )

      integer inputHistId, inputHistIdNoMask
      parameter( inputHistId=501, inputHistIdNoMask=500 )



c=== Common real numbers.


      real    tscan(maxChips*128*64)

c ORL: 3/18/98  Adding threshold scan histograms where masks aren't 
c                checked.
      real    tscanNoMask(maxChips*128*64)


      real    maxVal

      real    fitThresh(maxChips, 128)
      real    fitSigThresh(maxChips, 128)
      real    fitNoise(maxChips, 128)
      real    fitSigNoise(maxChips, 128)
      real    fitPtsUsed(maxChips, 128)
      real    fitChisqPdof(maxChips, 128)

      real    xl, xh
 
      common /qfit_r/ tscan, tscanNoMask, maxVal, fitThresh, 
     .                fitSigThresh,
     .                fitNoise, fitSigNoise, fitPtsUsed,
     .                fitChisqPdof, xl, xh



c=== Common character variables.

      character*80 dataFileBase, partName
      character*10 charRunNumber
 
      common /qfit_c/ dataFileBase, partName, charRunNumber



c=== Common integers.

      integer dfbLength, pnLength, rnLength
      integer nChips, runNumber, nx, ny

      common /qfit_i/ dfbLength, pnLength, rnLength, nChips, runNumber,
     .                nx, ny


c=== Common logical variables.

      logical saveChanHist

      common /qfit_l/ saveChanHist




