
      subroutine storePlots

      implicit none

      include 'quickfit.inc'
      include 'reversefreq.inc'
      include 'hcfitscom.inc'


      integer chip, chan, bin, chipId, chanId, icycle, lstat, place

      real    tmpThresh(128)
      real    tmpSigThresh(128)
      real    tmpNoise(128)
      real    tmpSigNoise(128)
      real    tmpScan(64)
      real    tmpSigScan(64)

      real    yval, err

      character*80 outFname

      external reversefreq

c++++++++++++++++



      
      print *,'  Filling histograms...'

      do chip = 0, nChips-1

         chipId = 100000 + 10*chip

         do chan = 0, 127

            tmpThresh(chan+1) = 63.-fitThresh(chip+1,chan+1)
            tmpSigThresh(chan+1) = fitSigThresh(chip+1,chan+1)
            tmpNoise(chan+1) = fitNoise(chip+1,chan+1)
            tmpSigNoise(chan+1) = fitSigNoise(chip+1,chan+1)
  

            if (saveChanHist) then

               do bin = 1, 64
                  yval = tscan(chip*128*64 + chan*64 + bin)
                  if (yval.le.maxVal) then
                     err = sqrt(yval*(maxVal-yval)/maxVal)
                  else
                     err = 0.
                  endif
                  tmpScan(bin) = yval
                  tmpSigScan(bin) = err
               enddo ! loop over threshold bins.

               chanId = 900000+128*chip+chan

               call hbarx(chanId)
               call hpak(chanId, tmpScan)
               call hpake(chanId, tmpSigScan)

            endif ! saving channel histograms.

         enddo ! loop over channels.

         call hbarx(chipId+1)
         call hbarx(chipId+2)

         call hpak(chipId+1, tmpThresh)
         call hpake(chipId+1, tmpSigThresh)
         call hpak(chipId+2, tmpNoise)
         call hpake(chipId+2, tmpSigNoise)


      enddo ! loop over chips.



c Construct the output file name.

      outFname = dataFileBase
      place = dfbLength+1

      outFname(place:place+1) = '/'
      place = place+1

      outFname(place:place+pnLength) = partName
      place = place+pnLength

      outFname(place:place+1) = '/'
      place = place+1

      outFname(place:place+6) = 'plots_'
      place = place+6

      outFname(place:place+rnLength) = charRunNumber(11-rnLength:10)
      place = place+rnLength

      outFname(place:place+4) = '.paw'




      print *,' '
      print *,' Opening output file ',outFname
      call hropen(99, 'outrz', outFname, 'n', 1024, lstat)



      print *,'  Saving histograms to file...'
      rfmax = maxVal

      do chip = 0, nChips-1

         chipId = 100000 + 10*chip

         call hrout(100+chip,icycle,' ')
         call hrout(200+chip,icycle,' ')
         call hrout(chipId+1, icycle, ' ')
         call hrout(chipId+2, icycle, ' ')

         write(*,300) chip
300      format('       Chip: ',i3)

         if (saveChanHist) then

            do chan = 0, 127

               chanId = 900000+128*chip+chan

               if (fitChisqPdof(chip+1,chan+1).gt.0) then

                  rfa = 63.-fitThresh(chip+1, chan+1)
                  rfb = fitNoise(chip+1, chan+1)
                  nfpar = 2
                  npfits = fitPtsUsed(chip+1, chan+1)
                  fitpar(1) = rfa
                  fitpar(2) = rfb
                  fitsig(1) = fitSigThresh(chip+1, chan+1)
                  fitsig(2) = fitSigNoise(chip+1, chan+1)
                  fitchi = fitChisqPdof(chip+1, chan+1)
                  call hfind(chanId, 'hfith ')
                  call hsupis(reversefreq, 0, 0, 0)
                  call hsupis(reversefreq, 1, 0, 0)
                  call hsupis(reversefreq, 3, 0, 0)
                  fitnam(1) = 'Thresh'
                  fitnam(2) = 'Noise'

               endif ! Fit worked.

               call hrout(chanId, icycle, ' ')

            enddo ! Loop over channels.

         endif ! Saving channel histograms.

      enddo ! Loop over chips.


C     call hrout(300,icycle,' ')
C     call hrout(400,icycle,' ')
      call hrend('outrz')

      return
      end
