c
c  Owen Long, UCSB  3/8/98
c
c  This program performs the same function as the make_fits kumac
c  except that it runs much faster.  The threshold scan fits 
c  take advantage of first and second derivative information
c  in the minimization of the chisquare.  This leads to a
c  much faster convergence since MINUIT assumes nothing in
c  the PAW fits.  MINUIT is not used in this program.
c  See the comments in fitchan.f for a description of the fitting
c  method.
c
c
      program quickfit

      implicit none

      integer stat


c++++++++++++


c Get the input data and parameters.
      call getInput( stat )
      if (stat.ne.0) goto 999

      
c Book the output histograms.
      call bookPlots


c Do the fits.
      call fitPlots


c Fill histograms and save to a file.
      call storePlots


c Write out vector info.
      call vecOutput


c Write out fit results in text file.
      call fitOutput


      print *,'  Done.'
      print *,' '


999   continue

      end

