c
c  This routine calculates the chisquare only using points with
c   binomial error.  It returns rChisq and rPtsUsed, where
c   rPtsUsed is the number of points used in the calculation.
c   Points above maxThreshDac are excluded.
c
      subroutine realChisq(chip,chan,a,b,rChisq,rPtsUsed)
      implicit none
      real a,b, rChisq
      integer chip, chan, rPtsUsed
      include 'quickfit.inc'
      integer i, ind
      real    yVal, errSq, xVal, Fval

      real    freq
      
c++++++++++++

      rChisq = 0.
      rPtsUsed = 0
      do i = 1, maxThreshDac
         ind = chip*128*64 + chan*64 + i
         if (tscan(ind).gt.0.and.tscan(ind).lt.maxVal) then
            yVal = tscan(ind)/maxVal
            errSq = yVal*(1.0-yVal)/maxVal
            xVal = 64. - i
            Fval = freq(xVal, a, b)
            if (errSq.gt.0) then
               rChisq = rChisq + ( (yVal - Fval)**2 ) / errSq
            endif
            rPtsUsed = rPtsUsed + 1
         endif
      enddo

      return
      end
