
      subroutine vecOutput

      implicit none

      include 'quickfit.inc'

      character*80 vecFname

      integer place, i, j, chip, chan
      real    tmpVec(maxChips*128)

c++++++++++++++++


      print *,' '
      print *,'  Saving vector info...'



c Construct the vector file name.

      vecFname = dataFileBase
      place = dfbLength+1

      vecFname(place:place+1) = '/'
      place = place+1

      vecFname(place:place+pnLength) = partName
      place = place+pnLength

      vecFname(place:place+1) = '/'
      place = place+1

      vecFname(place:place+6) = 'plots_'
      place = place+6

      vecFname(place:place+rnLength) = charRunNumber(11-rnLength:10)
      place = place+rnLength

      vecFname(place:place+4) = '.vec'

      write(*,810) vecFname
810   format('  Opening output vector file: ',a80)

c Write out vector info.

      open(unit=88, file=vecFname, status='unknown')

500   format(i5)
510   format(1x,g13.7,1x,g13.7)
520   format(i8)

      write(88,500) 64  ! Max channels in the fit (1 to 64).  ###
      write(88,500) nx  ! Number of x channels in input histogram.
      write(88,500) ny  ! Number of y channels in input histogram.
      write(88,510) xl, xh  ! Low and high range of x in input hist.
      write(88,520) 900000  ! Histogram offset.  ###
      write(88,500) nChips  ! Number of chips.
      write(88,500) runNumber    ! Run Number.
      write(88,500) int(maxVal)  ! Number of events per thresh setting.
      write(88,510) 0.01, 0.01   ! Step (not used in this program).
      write(88,510) -999.0, 0.0  ! Minimum values for thresh and noise
                                 !  (not used in this program).
      write(88,510) -999.0, 999.0 ! Maximum values for thresh and noise
                                  !  (not used in this program).

530   format(1x,g13.7, 1x,g13.7, 1x,g13.7, 1x,g13.7, 1x,g13.7)



c  Need to do it this way in order to conform with make_fits (sigh).
c   5 columns was a VERY BAD choice.

c Maximum values (not used in this program).
      do i = 1, (128*nChips)/5
         write(88,530) (0.0,j=1,5)
      enddo
      write(88,530) (0.0, j=1,mod(128*nChips,5))


c Thresholds.
      do chip = 1, nChips
         do chan = 1, 128
            tmpVec((chip-1)*128+chan) = 63. - fitThresh(chip,chan)
         enddo
      enddo
      do i = 1, (128*nChips)/5
         write(88,530) (tmpVec((i-1)*5+j),j=1,5)
      enddo
      write(88,530) (tmpVec(j), j=128*nChips-mod(128*nChips,5)+1,
     .                128*nChips)


c Noise values.
      do chip = 1, nChips
         do chan = 1, 128
            tmpVec((chip-1)*128+chan) = fitNoise(chip,chan)
         enddo
      enddo
      do i = 1, (128*nChips)/5
         write(88,530) (tmpVec((i-1)*5+j),j=1,5)
      enddo
      write(88,530) (tmpVec(j), j=128*nChips-mod(128*nChips,5)+1,
     .                128*nChips)


c Error on Maximum values (not used in this program).
      do i = 1, (128*nChips)/5
         write(88,530) (0.0,j=1,5)
      enddo
      write(88,530) (0.0, j=1,mod(128*nChips,5))


c Threshold Errors.
      do chip = 1, nChips
         do chan = 1, 128
            tmpVec((chip-1)*128+chan) = fitSigThresh(chip,chan)
         enddo
      enddo
      do i = 1, (128*nChips)/5
         write(88,530) (tmpVec((i-1)*5+j),j=1,5)
      enddo
      write(88,530) (tmpVec(j), j=128*nChips-mod(128*nChips,5)+1,
     .                128*nChips)


c Noise Errors.
      do chip = 1, nChips
         do chan = 1, 128
            tmpVec((chip-1)*128+chan) = fitSigNoise(chip,chan)
         enddo
      enddo
      do i = 1, (128*nChips)/5
         write(88,530) (tmpVec((i-1)*5+j),j=1,5)
      enddo
      write(88,530) (tmpVec(j), j=128*nChips-mod(128*nChips,5)+1,
     .                128*nChips)


c Chisquare/dof.
      do chip = 1, nChips
         do chan = 1, 128
            tmpVec((chip-1)*128+chan) = fitChisqPdof(chip,chan)
         enddo
      enddo
      do i = 1, (128*nChips)/5
         write(88,530) (tmpVec((i-1)*5+j),j=1,5)
      enddo
      write(88,530) (tmpVec(j), j=128*nChips-mod(128*nChips,5)+1,
     .                128*nChips)


c Done with vector file.

      close(88)


      return
      end

    



