/*--------------------------------------------------------------*/
/* Read record, stick it into buff                              */
/* Return number of bytes read.  Return -1 if an end of file    */
/* has been reached while reading first 4 bytes.  Return a      */
/* negative number if any other error has occurred              */ 
/*--------------------------------------------------------------*/
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

int read_record(FILE* fp, char** buff) {
  char *temp;
  int nread, num;

/*--- number of bytes in the record      */
  temp = (char *) malloc(4);
  if (temp == NULL) {
    return -999;
  }
  nread = fread(temp, 1, 4, fp);
  if (nread != 4) {
    if (feof(fp) != 0) return -1;
    return -999;
  }
  if (cal_extract(1, &num, temp) != 0) return -999;


/*--- read the record now            */
  *buff = (char *) malloc(num);
  if (*buff == NULL) return -999;
  *(*buff)    = *(temp);
  *(*buff+1)  = *(temp+1);
  *(*buff+2)  = *(temp+2);
  *(*buff+3)  = *(temp+3);
  free(temp);
  nread = fread((*buff+4), 1, (num-4), fp);
  if (nread != (num-4)) return -999;
  return num;
}
