#include "svtcommon.inc"

	integer istat,i,j,itemp,icycle,dummy
	integer read_event
	character*200 input_file 
	character*200 paw_file
	character*200 error_string
	integer iargc
	integer nevold, nrunold
        integer first_event, last_event

C============================================================
C Get the name of the input file and of the pawfile and the
C first event and the last event
C============================================================
	i = iargc()
	if (i .ne. 2) then
	   print *,' usage: svtana input_file paw_file'
	   stop
	end if
	call getarg(1, input_file)
	call getarg(2, paw_file)
ccccc	print *,' input file = ',input_file
ccccc	print *,' paw file   = ',paw_file
	print *,' enter the first event to be analyzed'
        read(5,1000)first_event
	print *,' enter the last event to be analyzed (-1=all)'
	read(5,1000)last_event
	if (last_event .ne. -1) then
	   if (last_event .lt. first_event) then
		print *,'last event must come AFTER first event'
	        stop
	   end if
	   if (last_event .le. 0) then
		print *,'last event should be > 0 or -1'
		stop
	   end if
	end if 
C============================================================
C set the size of PAWC
C============================================================
	call hlimit(NPAWC)
C============================================================
C Open the paw file
C============================================================
	call hropen(55,'svt',paw_file,'N',1024,istat)
	if (istat .ne. 0) then
        	print *,' error opening paw file'
         	stop
	end if
C============================================================
C Book the ntuple
C============================================================
	call hbnt(1,'SVT ntuple',' ')

	call hbname(1, 'GLOBAL', nchip, 'nchip[0,20],nrun,nev,'//
	1			     'ical_mask_all(8,nchip)[0,65535],'//
	1			     'ichan_mask_all(8,nchip)[0,65535],'//
	1			     'icreg(nchip)')
	call hbname(1, 'HIT', nhit, 'nhit[0,2560],'//
	1                            'ichipnum(nhit)[0,20],'//
	1                            'ichan(nhit)[0,127],'//
	1                            'itot(nhit)[0,15],'//
	1			     'itstamp(nhit)[0,31],'//
	1			     'itrcount(nhit)[0,31],'//
	1			     'itrtstamp(nhit)[0,31],'//
	1			     'ical_dac(nhit)[0,63],'//
	1			     'ithr_dac(nhit)[0,63],'//
	1			     'ical_msk(nhit)[0,1],'//
	1			     'icha_msk(nhit)[0,1]')

C============================================================
C Read the header
C============================================================
	i =1 
	dummy = read_event(i, input_file, nchip, nhit)
        if (dummy .ne. 0) then
	   call error_message(dummy, error_string)
	   print *,'Error from read_event ... reading event record'
	   print *,'Error code = ',dummy,'  ',error_string
	   stop
	end if
C============================================================
C Check it out         
C============================================================
c	write(6,900)nrun,nchip
c        do j=1,nchip
c	   do i=1,8
c	      write(6,901)j,i,ical_mask(i,j),ichan_mask(i,j)
c	   end do
c	end do
c900	format("Run =",i3," Numb of chips = ",i3)
c901     format("Chip ",i3," Masks ",i3,"    Cal ",z," Chan ",z)
C============================================================
C Read events
C============================================================
	nrunold = 0
	nevold  = 0
	i = 2
10	dummy = read_event(2, input_file, nchip, nhit)
	if (dummy .eq. 0) then
		j = nev/100
		if (100*j+1.eq.nev)print *,'processing run ',nrun,' event ',nev
		if (last_event .eq. -1 .or. (nev .ge. first_event .and.
     *              nev .le. last_event))  call hfnt(1)
	        if (last_event .ne. -1 .and. nev .gt. last_event) goto 999
	        nevold   = nev
	        nrunold = nrun
		goto 10
	else if (dummy .ne. -1) then
	   call error_message(dummy, error_string)
	   print *,'Error from read_event'
	   print *,'Last event processed was run ',nrunold,' event ',nevold
	   print *,'Error code = ',dummy,'  ',error_string
	   stop
	end if
C============================================================
C end the job
C============================================================
999     call hprnt(1)
	call hrout(1, ICYCLE, ' ')
	call hrend('svt')
        close(55)
1000	format(i8)
	end




